#
# Conditional build:
%bcond_without	avif		# AVIF support via libavif
%bcond_without	fontconfig	# fontconfig support
%bcond_without	heif		# HEIF support via libheif
%bcond_with	libimagequant	# LIQ quantization method support (breaks transparency in TrueColor->palette conversion)
%bcond_without	raqm		# RAQM complex text layout support
%bcond_with	sse		# SSE math on ix86
%bcond_without	xpm		# XPM support (requires X11 libs)
%bcond_without	tests		# "make check"
#
%ifarch pentium3 pentium4
%define	with_sse	1
%endif
Summary:	Library for PNG, JPEG creation
Summary(es.UTF-8):	Biblioteca para manipulación de imágenes
Summary(pl.UTF-8):	Biblioteka do tworzenia grafiki w formacie PNG, JPEG
Summary(pt_BR.UTF-8):	Biblioteca para manipulação de imagens
Name:		gd
Version:	2.3.3
Release:	7
License:	BSD-like
Group:		Libraries
#Source0Download: https://github.com/libgd/libgd/releases
Source0:	https://github.com/libgd/libgd/releases/download/%{name}-%{version}/lib%{name}-%{version}.tar.xz
# Source0-md5:	7a58b54d375eda236414201252a0ee3c
Patch0:		%{name}-fontpath.patch
Patch1:		%{name}-loop.patch
Patch2:		api-breakage.patch
Patch3:		%{name}-avif.patch
Patch4:		%{name}-heif.patch
URL:		https://libgd.github.io/
BuildRequires:	autoconf >= 2.54
BuildRequires:	automake
%{?with_fontconfig:BuildRequires:	fontconfig-devel}
BuildRequires:	freetype-devel >= 1:2.1.10
BuildRequires:	gettext-tools
%{?with_avif:BuildRequires:	libavif-devel >= 0.8.2}
%{?with_heif:BuildRequires:	libheif-devel >= 1.7.0}
%{?with_libimagequant:BuildRequires:	libimagequant-devel}
BuildRequires:	libjpeg-devel
BuildRequires:	libpng-devel >= 2:1.4.0
%{?with_raqm:BuildRequires:	libraqm-devel}
BuildRequires:	libtiff-devel >= 4
BuildRequires:	libtool >= 2:2
BuildRequires:	libwebp-devel >= 0.2.0
BuildRequires:	pkgconfig
BuildRequires:	sed >= 4
BuildRequires:	tar >= 1:1.22
%{?with_xpm:BuildRequires:	xorg-lib-libXpm-devel}
BuildRequires:	xz
BuildRequires:	zlib-devel
Requires:	freetype >= 1:2.1.10
%{?with_avif:Requires:	libavif >= 0.8.2}
%{?with_heif:Requires:	libheif >= 1.7.0}
Provides:	gd(gif) = %{version}-%{release}
# versioned by php version rotate_from_php code comes from
Provides:	gd(imagerotate) = 5.2.0
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
gd is the image manipulating library. It was created to allow graphs,
charts and the like to be generated on the fly for use on the World
wide Web, but is useful for any application in which custom images are
useful. It is not a paint program; it is a library. gd library creates
PNG, JPEG, GIF and WBMP images. PNG is a more compact format, and full
compression is available. JPEG works well with photographic images,
and is still more compatible with the major Web browsers than even PNG
is. WBMP is intended for wireless devices (not regular web browsers).

%description -l es.UTF-8
Esta es la biblioteca gd para el manejo de imágenes. Fue creada para
uso en la Web, creando gráficos automáticamente. Pero es útil para
cualquier programa que necesite de imágenes personalizados. No es un
programa de dibujo; es una biblioteca.

%description -l pl.UTF-8
gd to biblioteka do obróbki obrazów. Została stworzona, aby umożliwić
dynamiczne generowanie wykresów i podobnych rzeczy na potrzeby WWW,
ale może być przydatna także dla każdej aplikacji tworzącej własne
obrazy. Biblioteka ta pozwala na tworzenie plików graficznych w
formatach PNG, JPEG, GIF i WBMP. PNG jest zwartym formatem z
bezstratną kompresją. JPEG dobrze nadaje się do obrazów
fotograficznych i jest obsługiwany nawet przez więcej przeglądarek WWW
niż PNG. WBMP jest przeznaczony dla urządzeń bezprzewodowych (a nie
zwykłych przeglądarek WWW).

%description -l pt_BR.UTF-8
Esta é a biblioteca gd para manipulação de imagens. Ela foi criada
para uso na Web, gerando gráficos automaticamente. Mas é útil para
qualquer programa que precise de imagens personalizados. Não é um
programa de desenho; é uma biblioteca.

%package devel
Summary:	Development part of the GD library
Summary(es.UTF-8):	Archivos de inclusión y bibliotecas para desarrollar programas usando gd
Summary(pl.UTF-8):	Część biblioteki GD przeznaczona dla developerów
Summary(pt_BR.UTF-8):	Arquivos de inclusão e bibliotecas para desenvolver programas usando gd
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	fontconfig-devel
Requires:	freetype-devel >= 1:2.1.10
%{?with_avif:Requires:	libavif-devel >= 0.8.2}
%{?with_heif:Requires:	libheif-devel >= 1.7.0}
%{?with_libimagequant:Requires:	libimagequant-devel}
Requires:	libjpeg-devel
Requires:	libpng-devel
%{?with_raqm:Requires:	libraqm-devel}
Requires:	libtiff-devel >= 4
Requires:	libwebp-devel >= 0.2.0
%{?with_xpm:Requires:	xorg-lib-libXpm-devel}
Requires:	zlib-devel
Provides:	gd-devel(gif) = %{version}-%{release}
Provides:	gd-devel(imagerotate) = 5.2.0

%description devel
This package contains the files needed for development of programs
linked against GD.

%description devel -l es.UTF-8
Este paquete contiene los archivos de inclusión y las bibliotecas
necesarias para desarrollar programas usando gd.

%description devel -l pl.UTF-8
Pakiet ten zawiera pliki potrzebne do rozwoju programów korzystających
z biblioteki GD.

%description devel -l pt_BR.UTF-8
Este pacote contém os arquivos de inclusão e as bibliotecas
necessárias para desenvolver programas usando gd.

%package static
Summary:	Static GD library
Summary(pl.UTF-8):	Statyczna biblioteka GD
Summary(pt_BR.UTF-8):	Bibliotecas estáticas para desenvolvimento com libgd
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}
Provides:	gd-static(gif) = %{version}-%{release}
Provides:	gd-static(imagerotate) = 5.2.0

%description static
This package contains static gd library.

%description static -l pl.UTF-8
Ten pakiet zawiera statyczną bibliotekę gd.

%description static -l pt_BR.UTF-8
Este pacote contem bibliotecas estáticas para desenvolvimento com
libgd.

%package progs
Summary:	Utility programs that use libgd
Summary(es.UTF-8):	Programas utilitarios libgd
Summary(pl.UTF-8):	Narzędzia używające libgd
Summary(pt_BR.UTF-8):	Programas utilitários libgd
Group:		Applications/Graphics
Requires:	%{name} = %{version}-%{release}

%description progs
These are utility programs supplied with gd, the image manipulation
library. The libgd-progs package contains a group of scripts for
manipulating the graphics files in formats which are supported by the
libgd library.

%description progs -l pl.UTF-8
Ten pakiet zawiera programy używające biblioteki gd, służące do
obróbki plików graficznych w formatach obsługiwanych przez libgd.

%description progs -l pt_BR.UTF-8
Este pacote inclui vários utilitários para manipulação de arquivos gd
para uso pelos programas que usam a libgd.

%prep
%setup -q -n libgd-%{version}
%patch -P0 -p1
%patch -P1 -p1
%patch -P2 -p1
%patch -P3 -p1
%patch -P4 -p1

%build
%{__libtoolize}
%{__aclocal} -I m4
%{__automake}
%{__autoheader}
%{__autoconf}
%ifarch %{ix86}
%if %{with sse}
CFLAGS="%{rpmcflags} -msse -mfpmath=sse"
%endif
%endif
%configure \
	--enable-gd-formats \
	%{!?with_avif:--without-avif} \
	%{!?with_fontconfig:--without-fontconfig} \
	%{!?with_heif:--without-heif} \
	%{!?with_libimagequant:--without-liq} \
	%{!?with_raqm:--without-raqm} \
	%{!?with_xpm:--without-xpm}
%{__make}

%if %{with tests}
%ifarch %{ix86}
# https://github.com/libgd/libgd/issues/359
XFAIL_TESTS="$XFAIL_TESTS gdimagegrayscale/basic"
%if %{without sse}
# 387 arithmetic is inexact, https://github.com/libgd/libgd/issues/242
XFAIL_TESTS="$XFAIL_TESTS gdimagecopyresampled/bug00201"
%endif
%endif
%if %{with raqm}
# https://github.com/libgd/libgd/issues/613
XFAIL_TESTS="$XFAIL_TESTS gdimagestringft/gdimagestringft_bbox"
%endif
export XFAIL_TESTS
%{__make} check
%endif

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

# obsoleted by pkg-config
%{__rm} $RPM_BUILD_ROOT%{_libdir}/libgd.la

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc CONTRIBUTORS COPYING README.md
%attr(755,root,root) %{_libdir}/libgd.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libgd.so.3

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_libdir}/libgd.so
%{_includedir}/gd*.h
%{_pkgconfigdir}/gdlib.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libgd.a

%files progs
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/annotate
%attr(755,root,root) %{_bindir}/bdftogd
%attr(755,root,root) %{_bindir}/gd2copypal
%attr(755,root,root) %{_bindir}/gd2togif
%attr(755,root,root) %{_bindir}/gd2topng
%attr(755,root,root) %{_bindir}/gdcmpgif
%attr(755,root,root) %{_bindir}/gdparttopng
%attr(755,root,root) %{_bindir}/gdtopng
%attr(755,root,root) %{_bindir}/giftogd2
%attr(755,root,root) %{_bindir}/pngtogd
%attr(755,root,root) %{_bindir}/pngtogd2
%attr(755,root,root) %{_bindir}/webpng
%changelog
* Fri Mar 07 2025 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/gd.git;a=log;h=master

* Fri Mar 07 2025 Jakub Bogusz <qboosh@pld-linux.org> 345a743
- release 7 (libavif 1.2.x)

* Wed Mar 05 2025 Jakub Bogusz <qboosh@pld-linux.org> f27af23
- added some AVIF and HEIF fixes from git

* Wed Mar 05 2025 Jakub Bogusz <qboosh@pld-linux.org> 63a8100
- use patch -P

* Sun Mar 05 2023 Jakub Bogusz <qboosh@pld-linux.org> 7b587ea
- release 6 (libavif 0.11.x)

* Mon Jan 16 2023 Bartek Szady <bszx@bszx.eu> b3f3104
- enable gd formats as it was in the previous version; rel 5

* Mon Aug 22 2022 Jakub Bogusz <qboosh@pld-linux.org> 0439cb9
- drop .la file, release 4

* Mon Aug 22 2022 Jan Palus <atler@pld-linux.org> 7f9bd61
- rebuild for lerc library name change (transitive from libtiff)

* Fri Jun 03 2022 Jan Palus <atler@pld-linux.org> 5a97143
- remove 2.1.0-multilib patch never included in spec

* Fri Jun 03 2022 Jan Palus <atler@pld-linux.org> 68837b4
- add upstream revert of api breakage; rel 2

* Sat Apr 09 2022 Jakub Bogusz <qboosh@pld-linux.org> b2dd356
- updated to 2.3.3

* Thu Jul 01 2021 Jakub Bogusz <qboosh@pld-linux.org> b3e2ec2
- updated to 2.3.2
- removed obsolete missing patch
- added avif and heif support (via libavif and libheif)
- disable one heif test failing because of missing input file

* Sun Apr 19 2020 Jakub Bogusz <qboosh@pld-linux.org> 489009f
- updated to 2.3.0 (upstream fixes for CVE-2018-5711 CVE-2018-14553 CVE-2018-1000222 CVE-2019-6977 CVE-2019-6978 CVE-2019-11038)
- removed obsolete liq,Fix-OOB-read-due-to-crafted-GD-GD2-images,Fix-tiff_invalid_read-check,bmp-check-return-value-in-gdImageBmpPtr,heap-based-buffer-overflow,null-pointer,potential-double-free,upstream patches
- added missing patch (missing file from git)
- added raqm patch

* Sat Feb 01 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> 805d039
- use upstream patch instead of infinite loop fix

* Sat Feb 01 2020 Arkadiusz Miśkiewicz <arekm@maven.pl> 75d1220
- rel 5; fixes from FC

* Tue Jan 22 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> f510b22
- rel 4; fixes from debian

* Thu Aug 16 2018 Jan Rękorajski <baggins@pld-linux.org> c3e9c51
- rebuild without libjpeg.la
- release 3 (by relup.sh)

* Tue Feb 13 2018 Jan Rękorajski <baggins@pld-linux.org> e619ff9
- release 2 (by relup.sh)

* Tue Feb 13 2018 Jan Rękorajski <baggins@pld-linux.org> 63ee803
- fix tests
- remove obsolete patch that only breaks stuff now

* Sun Oct 29 2017 Arkadiusz Miśkiewicz <arekm@maven.pl> 8688bbf
- up to 2.2.5

* Sun Apr 23 2017 Jakub Bogusz <qboosh@pld-linux.org> 74fcde3
- added upstream patch (taken from Fedora): fixes tiff_invalid_read test failure
- release 2

